var _excluded = ["value", "testId", "onChange", "labelledBy", "describedBy", "className", "disabled", "color", "borderColor", "invalid", "height"];

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import { createStyledComponent } from '@cloudflare/style-container';
import { isDarkMode } from '@cloudflare/style-const';

var onSvg = darkMode => "<svg width=\"24\" height=\"24\" viewBox=\"0 0 24 24\" fill=\"none\" xmlns=\"http://www.w3.org/2000/svg\"><path d=\"M10.0275 16.2537L6 12.0462L7.08375 11.0075L10.0462 14.1013L16.0837 8L17.1487 9.05375L10.0275 16.2537Z\" fill=\"".concat(darkMode ? 'black' : 'white', "\"/></svg>");

var offSvg = darkMode => "<svg width=\"24\" height=\"24\" viewBox=\"0 0 24 24\" fill=\"none\" xmlns=\"http://www.w3.org/2000/svg\"><path d=\"M16.4687 17.4738L12.2688 13.3188L8.11375 17.5225L7.04875 16.465L11.2037 12.265L7 8.11L8.0575 7.045L12.2575 11.2L16.4125 7L17.4775 8.05375L13.3225 12.2538L17.5263 16.4087L16.4687 17.4738Z\" fill=\"".concat(darkMode ? 'black' : 'white', "\"/></svg>");

var backgroundImage = darkMode => "url('data:image/svg+xml;utf8,".concat(onSvg(darkMode), "'), url('data:image/svg+xml;utf8,").concat(offSvg(darkMode), "')");

var transition = 'all .25s ease';
var ToggleInput = createStyledComponent(_ref => {
  var {
    theme,
    height,
    controlSize,
    color,
    borderColor,
    invalid,
    disabled
  } = _ref;
  return _objectSpread(_objectSpread({
    appearance: 'none',
    position: 'relative',
    display: 'inline-block',
    width: "".concat(height * 2, "px"),
    minWidth: "".concat(height * 2, "px"),
    height: "".concat(height, "px"),
    opacity: disabled ? 0.5 : 1,
    transition: 'opacity .25s ease',
    borderRadius: "".concat(controlSize * 2, "px"),
    cursor: disabled ? 'not-allowed' : 'pointer'
  }, theme.mixins.focus({
    invalid
  })), {}, {
    ':before': {
      content: '" "',
      position: 'absolute',
      top: 0,
      right: 0,
      bottom: 0,
      left: 0,
      color: theme.colors.white,
      backgroundColor: invalid ? theme.colors.red[3] : theme.colors.gray[4],
      backgroundImage: backgroundImage(isDarkMode()),
      backgroundPosition: "".concat(height * 0.1, "px 0, ").concat(height * 0.9, "px 0"),
      backgroundRepeat: 'no-repeat',
      backgroundSize: 'contain',
      border: "1px solid ".concat(theme.colors.gray[2]),
      borderRadius: "".concat(height * 2, "px"),
      transition
    },
    ':after': {
      content: '" "',
      position: 'absolute',
      top: "".concat((height - controlSize) / 2, "px"),
      left: "".concat((height - controlSize) / 2, "px"),
      boxSizing: 'border-box',
      width: "".concat(controlSize, "px"),
      height: "".concat(controlSize, "px"),
      backgroundColor: theme.colors.background,
      borderRadius: "".concat(controlSize * 2, "px"),
      boxShadow: "0 0 2px 1px ".concat(theme.colors.gray[2]),
      transition
    },
    '&:checked:after': {
      transform: "translateX(".concat(height, "px)"),
      boxShadow: 'none'
    },
    '&:checked:before': {
      backgroundColor: invalid ? theme.colors.error : color !== null && color !== void 0 ? color : theme.colors.green[5],
      borderColor: invalid ? theme.colors.red[2] : borderColor !== null && borderColor !== void 0 ? borderColor : theme.colors.green[2]
    }
  });
}, 'input');

var Toggle = _ref2 => {
  var {
    value,
    testId,
    onChange,
    labelledBy,
    describedBy,
    className,
    disabled,
    color,
    borderColor,
    invalid,
    height = 24
  } = _ref2,
      rest = _objectWithoutProperties(_ref2, _excluded);

  var controlSize = height - 4;
  return /*#__PURE__*/React.createElement(ToggleInput, _extends({}, rest, {
    className: className,
    type: "checkbox",
    checked: value,
    height: height,
    controlSize: controlSize,
    color: color,
    borderColor: borderColor,
    disabled: disabled,
    invalid: invalid,
    onChange: disabled || !onChange ? undefined : e => onChange(e.target.checked),
    "data-testid": testId,
    "aria-labelledby": labelledBy,
    "aria-describedby": describedBy,
    "aria-invalid": invalid || undefined
  }));
};

export default Toggle;